﻿Imports ThinkGeo
Imports ThinkGeo.MapSuite
Imports ThinkGeo.MapSuite.Core
Imports ThinkGeo.MapSuite.DesktopEdition

Public Class Shell
  Private _trackOverlay As CustomTrackInteractiveOverlay

  Private Sub btnClear_Click(sender As System.Object, e As System.EventArgs) Handles btnClear.Click
    With Map.EditOverlay
      If .EditShapesLayer.InternalFeatures.Count > 0 Then
        .Lock.EnterWriteLock()
        .EditShapesLayer.InternalFeatures.Clear()
        .Lock.ExitWriteLock()

        Map.Refresh()
      End If
    End With

    Map.TrackOverlay.TrackMode = TrackMode.Polygon
  End Sub

  Private Sub Shell_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load
    _trackOverlay = New CustomTrackInteractiveOverlay
    Map.TrackOverlay = _trackOverlay

    Map.MapUnit = GeographyUnit.DecimalDegree

    AddHandler _trackOverlay.TrackEnded, AddressOf _trackOverlay_TrackEnded

    InteractiveOverlay.InteractiveClickInterval = 1

    Dim ext As RectangleShape = New RectangleShape(New PointShape(-94.8200383477655, 41.8474622052207), New PointShape(-94.8180830406505, 41.8453812197797))

    Map.CurrentExtent = ext

    Map.Refresh()

    Map.TrackOverlay.TrackMode = TrackMode.Polygon
  End Sub

  Private Sub _trackOverlay_TrackEnded(sender As Object, e As ThinkGeo.MapSuite.DesktopEdition.TrackEndedTrackInteractiveOverlayEventArgs)
    If _cancelTrack Then
      _cancelTrack = False
    Else
      _trackOverlay.TrackMode = TrackMode.None

      InteractiveOverlay.InteractiveClickInterval = 1

      Map.TrackOverlay.Lock.EnterWriteLock()

      Map.TrackOverlay.TrackShapeLayer.InternalFeatures.Clear()

      Map.TrackOverlay.Lock.ExitWriteLock()

      Dim f As New Feature(e.TrackShape)

      Map.EditOverlay.Lock.EnterWriteLock()

      Map.EditOverlay.EditShapesLayer.InternalFeatures.Add(f)
      Map.EditOverlay.CalculateAllControlPoints()
      Map.EditOverlay.CanRemoveVertex = True

      Map.EditOverlay.Lock.ExitWriteLock()

      Map.Refresh()
    End If
  End Sub

  Private _cancelTrack As Boolean = False

  Private Sub Map_KeyDown(sender As Object, e As System.Windows.Forms.KeyEventArgs) Handles Map.KeyDown
    If e.KeyCode = Windows.Forms.Keys.Escape Then
      _cancelTrack = True
      'RemoveHandler _trackOverlay.TrackEnded, AddressOf _trackOverlay_TrackEnded

      Map.TrackOverlay.Lock.EnterWriteLock()

      Try
        Dim count As Integer = Map.TrackOverlay.TrackShapeLayer.InternalFeatures.Count
        If count > 0 Then
          Map.TrackOverlay.TrackShapeLayer.InternalFeatures.Clear()
        End If

        If Map.TrackOverlay.TrackMode = TrackMode.Polygon Then
          CType(Map.TrackOverlay, CustomTrackInteractiveOverlay).EndTracking()
          Map.TrackOverlay.MouseDoubleClick(New InteractionArguments)
        Else
          Map.TrackOverlay.MouseUp(New InteractionArguments())
        End If
      Catch ex As Exception
      Finally
        Map.TrackOverlay.Lock.ExitWriteLock()
      End Try

      'If Map.TrackOverlay.TrackMode = TrackMode.Polygon OrElse _
      '   Map.TrackOverlay.TrackMode = TrackMode.Line Then

      '  CType(Map.TrackOverlay, CustomTrackInteractiveOverlay).EndTracking()
      '  Map.TrackOverlay.MouseDoubleClick(New InteractionArguments)
      'Else
      '  Map.TrackOverlay.MouseUp(New InteractionArguments())
      'End If

      Map.Refresh()
    End If

    'AddHandler _trackOverlay.TrackEnded, AddressOf _trackOverlay_TrackEnded
  End Sub
End Class
